HDU 5389 Zero Escape(dp解法)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389

题面:

Zero Escape

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)

Total Submission(s): 164    Accepted Submission(s): 73

Problem Description

Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.

Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.

This is the definition of digital root on Wikipedia:

The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number
is reached.

For example, the digital root of 65536
is 7,
because 6+5+5+3+6=25
and 2+5=7.

In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered
X(1≤X≤9),
the digital root of their identifier sum must be X.

For example, players {1,2,6}
can get into the door 9,
but players {2,3,3}
can‘t.

There is two doors, numbered A
and B.
Maybe A=B,
but they are two different door.

And there is n
players, everyone must get into one of these two doors. Some players will get into the door
A,
and others will get into the door B.

For example:

players are {1,2,6},
A=9,
B=1

There is only one way to distribute the players: all players get into the door
9.
Because there is no player to get into the door 1,
the digital root limit of this door will be ignored.

Given the identifier of every player, please calculate how many kinds of methods are there,
mod 258280327.

Input

The first line of the input contains a single number
T,
the number of test cases.

For each test case, the first line contains three integers
n,
A
and B.

Next line contains n
integers idi,
describing the identifier of every player.

T≤100,
n≤105,
∑n≤106,
1≤A,B,idi≤9

Output

For each test case, output a single integer in a single line, the number of ways that these
n
players can get into these two doors.

Sample Input

4
3 9 1
1 2 6
3 9 1
2 3 3
5 2 3
1 1 1 1 1
9 9 9
1 2 3 4 5 6 7 8 9

Sample Output

1
0
10
60

Source

2015 Multi-University Training Contest 8

解题:

开始没想到递推,队友说了下dp,往这方面想了下就想到了。状态转移方程为dp[i][j]=(dp[i-1][tmp]+dp[i-1][j])%mod;其中tmp为j-arr[i],i是当前下标,j从1到9,若算出的tmp小于等于0还需加上9。dp[i][j]的含义是到第i位为止,前i个数中的若干个加起来和为j的方案数,转移方程中的两项分别对应,当前i位取或不取。因为每个数字是由确定的两个数字组合加起来得到的,比如2,若其中一个为1,那么另外一个也一定为1。且存在这样的性质,若干个数,按给定的规则先加,或者分开加,再组合在一起,得到的结果是一样的。故可以先预先把所有的数加起来,若其和和a+b得到的结果相同,那么直接取dp[n][a]+dp[n][b]的值即可,若不同,那么只可以放在任意门中,分别检查一下即可。

代码:

#include <iostream>
#include <cstring>
#include <cstdio>
#define mod 258280327
using namespace std;
int dp[100010][10],arr[100010];
//按给定规则转化为个位数
int modify(int x)
{
    int res=0;
    while(x)
    {
        res+=(x%10);
        x/=10;
    }
    if(res>9)
        return modify(res);
    else
        return res;
}
int main()
{
    int t,n,a,b,tmp,ans;
    int sum,xx;
    scanf("%d",&t);
    while(t--)
    {
        sum=0;
		//初始化
        memset(dp,0,sizeof(dp));
        scanf("%d%d%d",&n,&a,&b);
		//读入
        for(int i=1;i<=n;i++)
            scanf("%d",&arr[i]);
        for(int i=1;i<=n;i++)
        {
			//并同时转化为对应的个位数
            arr[i]=modify(arr[i]);
            sum+=arr[i];
        }
        sum=modify(sum);
        xx=a+b;
        xx=modify(xx);
		//看是否相等
        if(sum==xx)
        {
          dp[1][arr[1]]=1;
          for(int i=2;i<=n;i++)
          {
              for(int j=1;j<=9;j++)
              {
                  tmp=j-arr[i];
                  if(tmp<=0)
                     tmp+=9;
				  //当前位分别取1-9,由前面对应的关系推过来
                  dp[i][j]=(dp[i-1][tmp]+dp[i-1][j])%mod;
              }
          }
        printf("%d\n",(dp[n][a]+dp[n][b])%mod);
       }
		//不相等,只可能单独在一扇门中
       else
       {
           ans=0;
           if(sum==a)
              ans++;
           if(sum==b)
               ans++;
           printf("%d\n",ans);
       }
    }
    return 0;
}

如有疑问,欢迎交流

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-19 06:00:25

HDU 5389 Zero Escape(dp解法)的相关文章

hdu 5389 Zero Escape (dp)

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5389 题意:定义数根:①把每一位上的数字加起来得到一个新的数,②重复①直到得到的数只有1位.给定n,A,B和n个一位数,求把这n个数分成两部分,使得这两部分的其中一部分的和的数根等于A另外一部分的和的数根等于B的方案数. 分析:一个数a的数根s=(a-1)%9+1,为了方便直接用s=a%9,其中0代表9.定义dp[i][j]表示前i个数中数根为j的方案数.对于第i个数可以选也可以不选,那么状态转移方程为

HDU 5389 Zero Escape(DP + 滚动数组)

Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 864    Accepted Submission(s): 438 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchik

HDU 5389 Zero Escape(dp啊 多校啊 )

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter of

HDU 5389 Zero Escape(dp啊 多校)

题目链接:http://acm.hdu.edu.cn/showproblem.php? pid=5389 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter o

HDU 5389 Zero Escape (MUT#8 dp优化)

[题目链接]:click here~~ [题目大意]: 题意: 给出n个人的id,有两个门,每个门有一个标号,我们记作a和b,现在我们要将n个人分成两组,进入两个门中,使得两部分人的标号的和(迭代的求,直至变成一位数,我们姑且叫做求"和"操作~)分别等于a和b,问有多少种分法. [思路]:比赛的时候还是学弟递推的方程,当时是dp三维dp[i][j]k]:分别表示枚举到第i位,A门,B门的状态,但是一直没想到怎么进一步优化,卡在100n的复杂度了 赛后看了一下题解,(虽然高中生写的题解看

HDU 5389 Zero Escape (类0/1背包)

Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 883    Accepted Submission(s): 452 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchik

hdu 5389 Zero Escape

传送门 Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1460    Accepted Submission(s): 716 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro U

HDOJ 5389 Zero Escape DP

一个数的数字根只和它mod~9mod 9之后的值有关,只要类似背包就能完成人员分配的计算. 具体证明:数字根=\sum_{i=0}^{w}a_i∑?i=0?w??a?i??,数字=\sum_{i=0}^{w}10^i*a_i∑?i=0?w??10?i???a?i?? 数字-数字根=\sum_{i=0}^{w}(10^i-1)*a_i∑?i=0?w??(10?i???1)?a?i??,这个数字在modmod 99域下为00 Zero Escape Time Limit: 2000/1000 MS

hdu(5389)——Zero Escape(01背包变形)

啊,这是一道挺不错的动态规划的题目呢. 一开始我们并没有找出规律,后来队友突然喊了一句:"dp啊!" 顿时人生豁然开朗了... 于是她很神奇的推出了转移方程,然后再共同查错下,a出了这道题,真是佩服这人的高智商啊 题意: 首先n,代表的是n个人,然后是A,B,分别代表两个门的值. 然后第二行给出了n个人的价值,问你要使这n个人全部进入门中(可以是A,B,或是其中的一扇门),总共有几种方法. 但是要注意这里的价值并不是仅仅加起来就好了,这里是要把它加起来直到为一个个位数. 思路: 定义: